/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 */

package ca.uhn.hl7v2.model.v26.group;

import ca.uhn.hl7v2.model.v26.segment.*;

import ca.uhn.log.HapiLogFactory;
import ca.uhn.hl7v2.HL7Exception;
import ca.uhn.hl7v2.parser.ModelClassFactory;
import ca.uhn.hl7v2.parser.DefaultModelClassFactory;
import ca.uhn.hl7v2.model.AbstractMessage;
import ca.uhn.hl7v2.model.Group;
import ca.uhn.hl7v2.model.AbstractGroup;
import ca.uhn.hl7v2.model.GenericSegment;

/**
 * <p>Represents a CSU_C09_STUDY_PHASE group structure (a Group object).
 * A Group is an ordered collection of message segments that can repeat together or be optionally in/excluded together.
 * This Group contains the following elements:  
 * </p>
 * <ul>
                 * <li>1: CSP (Clinical Study Phase) <b>optional </b></li>
                 * <li>2: CSU_C09_STUDY_SCHEDULE (a Group object) <b> repeating</b></li>
 * </ul>
 */
public class CSU_C09_STUDY_PHASE extends AbstractGroup {

    /** 
     * Creates a new CSU_C09_STUDY_PHASE group
     */
    public CSU_C09_STUDY_PHASE(Group parent, ModelClassFactory factory) {
       super(parent, factory);
       init(factory);
    }

    private void init(ModelClassFactory factory) {
       try {
                          this.add(CSP.class, false, false);
                          this.add(CSU_C09_STUDY_SCHEDULE.class, true, true);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error creating CSU_C09_STUDY_PHASE - this is probably a bug in the source code generator.", e);
       }
    }

    /** 
     * Returns "2.6"
     */
    public String getVersion() {
       return "2.6";
    }



    /**
     * Returns
     * CSP (Clinical Study Phase) - creates it if necessary
     */
    public CSP getCSP() { 
       CSP ret = null;
       try {
          ret = (CSP)this.get("CSP");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }




    /**
     * Returns
     * the first repetition of 
     * STUDY_SCHEDULE (a Group object) - creates it if necessary
     */
    public CSU_C09_STUDY_SCHEDULE getSTUDY_SCHEDULE() { 
       CSU_C09_STUDY_SCHEDULE ret = null;
       try {
          ret = (CSU_C09_STUDY_SCHEDULE)this.get("STUDY_SCHEDULE");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns a specific repetition of
     * STUDY_SCHEDULE (a Group object) - creates it if necessary
     *
     * @param rep The repetition index (0-indexed, i.e. the first repetition is at index 0)
     * @throws HL7Exception if the repetition requested is more than one 
     *     greater than the number of existing repetitions.
     */
    public CSU_C09_STUDY_SCHEDULE getSTUDY_SCHEDULE(int rep) { 
       CSU_C09_STUDY_SCHEDULE ret = null;
       try {
          ret = (CSU_C09_STUDY_SCHEDULE)this.get("STUDY_SCHEDULE", rep);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    /** 
     * Returns the number of existing repetitions of STUDY_SCHEDULE 
     */ 
    public int getSTUDY_SCHEDULEReps() { 
        int reps = -1; 
        try { 
            reps = this.getAll("STUDY_SCHEDULE").length; 
        } catch (HL7Exception e) { 
            String message = "Unexpected error accessing data - this is probably a bug in the source code generator."; 
            HapiLogFactory.getHapiLog(this.getClass()).error(message, e); 
            throw new RuntimeException(message);
        } 
        return reps; 
    } 

    /**
     * Inserts a specific repetition of STUDY_SCHEDULE (a Group object)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public void insertSTUDY_SCHEDULE(CSU_C09_STUDY_SCHEDULE structure, int rep) throws HL7Exception { 
       super.insertRepetition("STUDY_SCHEDULE", structure, rep);
    }


    /**
     * Inserts a specific repetition of STUDY_SCHEDULE (a Group object)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public CSU_C09_STUDY_SCHEDULE insertSTUDY_SCHEDULE(int rep) throws HL7Exception { 
       return (CSU_C09_STUDY_SCHEDULE)super.insertRepetition("STUDY_SCHEDULE", rep);
    }


    /**
     * Removes a specific repetition of STUDY_SCHEDULE (a Group object)
     * @see AbstractGroup#removeRepetition(String, int) 
     */
    public CSU_C09_STUDY_SCHEDULE removeSTUDY_SCHEDULE(int rep) throws HL7Exception { 
       return (CSU_C09_STUDY_SCHEDULE)super.removeRepetition("STUDY_SCHEDULE", rep);
    }



}

